#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glut.h>

#include "Object2df.h"
#include "Card.h"

CCard::CCard(void){
	objectPtr=NULL;
	cardState=SHOW_BACK;
}

CCard::~CCard(void){}

void CCard::draw(){
	glPushMatrix();
	glTranslatef(cx,cy,0);
	switch(cardState){
		case INVISIBLE: break;
		case SHOW_FRONT:
			glColor3f(0,0,0);	
			glRecti(-CARD_WIDTH / 2, -CARD_HEIGHT / 2, CARD_WIDTH / 2, CARD_HEIGHT / 2);
			objectPtr->draw();
			break;
		case SHOW_BACK:
			glColor3f(0.5,0.5,0.5);	
			glRecti(-CARD_WIDTH / 2, -CARD_HEIGHT / 2, CARD_WIDTH / 2, CARD_HEIGHT / 2);
			break;
		default:;
	}
	glPopMatrix();
}

void CCard::init(int p, CObject2df* oPtr){
	objectPtr=oPtr;
	cx=(p%5+1)*(CARD_WIDTH+30);
	cy=(p/5+1)*(CARD_HEIGHT+30);
}

bool CCard::isSelected(int x, int y){
	return ((cx>=x-CARD_WIDTH / 2) && (cx<=x+CARD_WIDTH / 2) && (cy>=y-CARD_HEIGHT / 2) && (cy<=y+CARD_HEIGHT / 2));
}

