#include <math.h>
#include "MyMath.h"

/////////////////////
// Class CVec2df   //
/////////////////////

CVec2df::CVec2df()
{
	v=new float[2];
	v[X]=0.0f; v[Y]=0.0f;
}

CVec2df::CVec2df(float x, float y)
{
	v=new float[2];
	v[X]=x; v[Y]=y;
}

CVec2df::CVec2df(const CVec2df& vec)
{
	v=new float[2];
	v[X]=vec[X]; v[Y]=vec[Y];
}

CVec2df::~CVec2df(){ delete[] v;}

void CVec2df::set(float x, float y) { v[0]=x, v[1]=y;}
const float* CVec2df::getV() { return v;}

CVec2df& CVec2df::operator=(const CVec2df& v1)
{
	v[X] = v1.v[X]; v[Y] = v1.v[Y];
	return *this;
}

CVec2df& CVec2df::operator+=(const CVec2df& v1)
{
	v[X] += v1.v[X]; v[Y] += v1.v[Y]; 
	return *this;
}

CVec2df& CVec2df::operator-=(const CVec2df& v1)
{
	v[X] -= v1.v[X]; v[Y] -= v1.v[Y]; 
	return *this;
}

CVec2df& CVec2df::operator*=(float scalar)
{
	v[X] *= scalar; v[Y] *= scalar;
	return *this;
}

CVec2df& CVec2df::operator/=(float scalar)
{
	v[X] /= scalar; v[Y] /= scalar; 
	return *this;
}

CVec2df operator+(const CVec2df& v1, const CVec2df& v2)
{
	return CVec2df(v1.v[X] + v2.v[X], v1.v[Y] + v2.v[Y]);
}

CVec2df operator-(const CVec2df& v1, const CVec2df& v2)
{
	return CVec2df(v1.v[X] - v2.v[X], v1.v[Y] - v2.v[Y]);
}

CVec2df operator*(float scalar, const CVec2df& v1)
{
	CVec2df v0 = v1;
	v0 *= scalar;
	return v0;
}

CVec2df operator-(const CVec2df& v1)
{
	return CVec2df(-v1.v[X], -v1.v[Y]);
}

bool operator==(const CVec2df& v1, const CVec2df& v2)
{
	return ((v1[X]==v2[X]) && (v1[Y]==v2[Y]));
}

bool operator!=(const CVec2df& v1, const CVec2df& v2)
{
	return ((v1[X]!=v2[X]) || (v1[Y]!=v2[Y]));
}

/////////////////////////////////////////////
// INSERT HERE YOUR ANSWERS TO QUESTION 3a //
/////////////////////////////////////////////

/////////////////////////////////////////////
// INSERT HERE YOUR ANSWERS TO QUESTION 3b //
/////////////////////////////////////////////
