#if !defined(LECTURE372_MYMATH)
#define LECTURE372_MYMATH

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef enum { X, Y, W } Axis;	// includes 2D homogenous coordinates
const double PI=3.141592653589793238462643383279502884197;

#include <iostream>
using namespace std;

class CVec2df  
{
public:
	CVec2df();
	CVec2df(float x, float y);
	CVec2df(const CVec2df& v);
	virtual ~CVec2df();
	const float* getV();
	void set(float x, float y);
	
	// Assignment operator
	CVec2df& operator=(const CVec2df& v1);
	
	// index operator
	float& operator[](int index) const { return v[index]; }

	// arithmetic operations
	CVec2df& operator+=(const CVec2df& v1);
	CVec2df& operator-=(const CVec2df& v1);
	CVec2df& operator*=(float scalar);  
	CVec2df& operator/=(float scalar);
	friend CVec2df operator+(const CVec2df& v1, const CVec2df& v2);
	friend CVec2df operator-(const CVec2df& v1, const CVec2df& v2);
	friend CVec2df operator-(const CVec2df& v1);
/////////////////////////////////////////////
// INSERT HERE YOUR ANSWERS TO QUESTION 3a //
/////////////////////////////////////////////

	// boolean operations
	friend bool operator==(const CVec2df& v1, const CVec2df& v2);
	friend bool operator!=(const CVec2df& v1, const CVec2df& v2);

	// output operation
/////////////////////////////////////////////
// INSERT HERE YOUR ANSWERS TO QUESTION 3b //
/////////////////////////////////////////////

private:
	float *v;
};



#endif // !defined(LECTURE372_MYMATH)
